class Strom {
	Polozka vrchol;
	
	public Strom() {
		this.vrchol = null;
	}
	
	public void pridatRVlevo(Polozka polozka, String cisla, int vnoreni) {
		if (cisla.length()-1<vnoreni) return;
		
		Polozka novaPolozka = new Polozka(Character.getNumericValue(cisla.charAt(vnoreni)));
		polozka.vlevo = novaPolozka;
		
		this.pridatRVlevo(novaPolozka, cisla, vnoreni*2+1);
		this.pridatRVpravo(novaPolozka, cisla, vnoreni*2+2);
	}

	public void pridatRVpravo(Polozka polozka, String cisla, int vnoreni) {
		if (cisla.length()-1<vnoreni) return;
		
		Polozka novaPolozka = new Polozka(Character.getNumericValue(cisla.charAt(vnoreni)));
		polozka.vpravo = novaPolozka;
		
		this.pridatRVlevo(novaPolozka, cisla, vnoreni*2+1);
		this.pridatRVpravo(novaPolozka, cisla, vnoreni*2+2);
	}
	
	public void pridat(String cisla) {
		if (cisla.length()==0) return;
		Polozka polozka = new Polozka(Character.getNumericValue(cisla.charAt(0)));
		this.vrchol = polozka;
		
		this.pridatRVlevo(polozka, cisla, 1);
		this.pridatRVpravo(polozka, cisla, 2);
	}
	
	public void preorderR(Polozka polozka) {
		System.out.print(polozka.klic+" ");
		if (polozka.vlevo != null) this.preorderR(polozka.vlevo);
		if (polozka.vpravo != null) this.preorderR(polozka.vpravo);
	}
		
	public void preorder() {
		this.preorderR(this.vrchol);
		System.out.println();
	}
	
	public void inorderR(Polozka polozka) {
		if (polozka.vlevo != null) this.inorderR(polozka.vlevo);
		System.out.print(polozka.klic+" ");
		if (polozka.vpravo != null) this.inorderR(polozka.vpravo);
	}
		
	public void inorder() {
		this.inorderR(this.vrchol);
		System.out.println();
	}
	
	public void postorderR(Polozka polozka) {
		if (polozka.vlevo != null) this.postorderR(polozka.vlevo);
		if (polozka.vpravo != null) this.postorderR(polozka.vpravo);
		System.out.print(polozka.klic+" ");
	}
		
	public void postorder() {
		this.postorderR(this.vrchol);
		System.out.println();
	}
}